rem echo off
if x%1==x goto noparams
if exist ..\bin\vcc.exe goto compiler_in_dotdot
if exist c:\vskit\bin\vcc.exe goto compiler_in_c_root
SET VSBIN=  
goto compile

:compiler_in_dotdot
SET VSBIN=..\bin\
goto compile

:compiler_in_c_root
SET VSBIN=c:\vskit\bin\
goto compile

:compile
rem echo Compiling the Assember Support Functions...
%VSBIN%vsa fat12adc.s -I lib
rem echo Compiling %1.c ...
%VSBIN%vcc -P130 -O -fsmall-code -I lib -o a_out.o %1.c
IF ERRORLEVEL 1 GOTO vccfail
:link
rem echo Linking for Nand Flash loading... (combining with libraries)
%VSBIN%vslink -k -m mem_user -L lib -lc -ldev1000 -o o_nand.bin lib/c-nand.o lib/rom1000.o a_out.o fat12adc.o > nul
IF ERRORLEVEL 1 GOTO linkfail

rem echo Linking for Emulator and SPI EEPROM loading... (combining with libraries)
%VSBIN%vslink -k -m mem_user -L lib -lc -ldev1000 -o o_emuspi.bin lib/c-spi.o lib/rom1000.o a_out.o fat12adc.o > nul
IF ERRORLEVEL 1 GOTO linkfail
rem echo ==OK== Emulator runnable program is now in o_emuspi.bin.
%VSBIN%coff2nandboot -t 0 -b 5 -s 15 -x 0x50 o_emuspi.bin EXECFILE.PRG > nul
rem echo ==OK== Exec() -loadable file is in EXECFILE.PRG

rem echo Creating SPI EEPROM image (25LC640 etc)...
%VSBIN%coff2spiboot -x 0x50 o_emuspi.bin ee_%1.img
rem echo ==OK== EEPROMmable image is now in ee_%1.img
:load

rem echo -
echo ==OK== Compilation seems to be successful.
rem %VSBIN%vssym -Q o_emuspi.bin
if x%2==xNOLOAD goto :end
echo Switch VS1000 on now. (You may need to turn vs1000 power off first)
echo Remember that you may need to clear code from nand flash before loading.
rem echo Hit [Ctrl-C] to quit this batch job or [Enter] to load code via emulator
pause >null
%VSBIN%vs3emu -chip vs1000 -s 115200 -l o_emuspi.bin e.cmd
goto end


:linkfail
echo The %1.c file was compiled but not linked. This probably means that there is something wrong with a call to the libarary functions or the library functions are not found.
pause
goto end

:vccfail
The file %1.c was not compiled. Either the compiler is not found or there is an error in the file.
if exist %VSBIN%vcc.exe goto end
echo The compiler was not found, you can put vcc.exe into c:\vskit\bin\vcc.exe
pause
goto end


:noparams
echo VLSI Script for building the Tiny Player source code
echo Usage:    BuildTinyPlayer MainFileNameWithoutDotC
echo Example:  If your source file name is spiusb.c, use the command
echo           BuildTinyPlayer spiusb
goto end

:end
