#define FILSYSTYPE 13
#define	ASM
#include <vs1000.h>


// Prototypes for C calling:	
// auto u_int16 OpenFile(register __c0 u_int16 fileNum); 
// auto u_int16 Fat12OpenFile(register __c0 u_int16 fileNum); 
// void SetInterruptVector_Timer1(void);
// void SetInterruptVector_GPIO0(void);
// void InterruptHandler_Timer1(void); 


				
	.sect code,Fat12OpenFile

#if 0	
	.export _Fat12OpenFile
_Fat12OpenFile:
	.import _minifatInfo
	ldc _minifatInfo+FILSYSTYPE,i7
	stx d0,(i6)+1	; sty b0,(i6)
	stx ls,(i6)+1	; sty lc,(i6)
	ldy (i7),d0	; stx le,(i6)
	ldc 0x3231,b0
	sub d0,b0,d0	; sty lr0,(i6)+1
	ldc 0x6eab,le	//directory detected
	jzc $0
	ldc 0xffff,lc

	ldc 0x6f06,ls	//update position etc..
	//ldc 0x6ecb,ls

$0:	.import _FatOpenFile
	call _FatOpenFile
	nop

	ldx (i6)-1,le	; ldy (i6),lr0
	ldx (i6)-1,ls	; ldy (i6),lc
	jr
	ldx (i6)-1,d0	; ldy (i6),b0


#endif	

#if 0
//This fuction sets the vector to point to caller stub...
//This is done by copying a caller opcode to the vector(!)
	.sect code,SetInterruptVector_Timer1
	.export _SetInterruptVector_Timer1	
_SetInterruptVector_Timer1:
	ldx (i6)+1,null
	stx a0,(i6) ; sty a1,(i6)
	ldc timer1_int_stub - 1,i7
	ldi (i7),a    //Read caller opcode from timer1_int_stub-1
	ldc 0x0027,i7 //Select vector... 0x0027 is Timer 1 vector
	sti a,(i7)    //Insert the caller opcode to the vector
	nop           //no control change possible just after sti/ldi!
	jr
	ldx (i6)-1,a0 ; ldy (i6),a1 //executed in jr delay slot



	
//This is the Interrupt Caller Stub:	
	jmpi timer1_int_stub,(i6)+1 // DO NOT MOVE!!!	
timer1_int_stub:

  // Context Save
	stx mr0,(i6)+1    ; sty i7,(i6)
	stx lr1,(i6)+1    ; sty lr0,(i6)
	stx a2,(i6)+1     ; sty b2,(i6)
	stx c2,(i6)+1     ; sty d2,(i6)
	stx a1,(i6)+1     ; sty a0,(i6)
	add null,p,a
	stx a1,(i6)+1     ; sty a0,(i6)

	.import _InterruptHandler_Timer1
	call _InterruptHandler_Timer1
	sty i5,(i6)

  // Context Restore	
	ldy (i6)-1,i5
	ldx (i6)-1,a1     ; ldy (i6),a0
	resp a0,a1
	ldx (i6)-1,a1     ; ldy (i6),a0
	ldx (i6)-1,c2     ; ldy (i6),d2
	ldx (i6)-1,a2     ; ldy (i6),b2
	ldx (i6)-1,lr1    ; ldy (i6),lr0
	ldc INT_GLOB_EN,i7 //Acknowledge
	ldx (i6),mr0
	reti
	stx i7,(i7)       ; ldy (i6)-1,i7 //Allow interrupts

#endif
	

//This fuction sets the vector to point to caller stub...
//This is done by copying a caller opcode to the vector(!)
	.sect code,SetInterruptVector_GPIO0
	.export _SetInterruptVector_GPIO0	
_SetInterruptVector_GPIO0:
	ldx (i6)+1,null
	stx a0,(i6) ; sty a1,(i6)
	ldc gpio0_int - 1,i7
	ldi (i7),a    //Read caller opcode from timer1_int_stub-1
	ldc 0x0029,i7 //Select vector... 0x0029 is GPIO0 vector
	sti a,(i7)    //Insert the caller opcode to the vector
	nop           //no control change possible just after sti/ldi!
	jr
	ldx (i6)-1,a0 ; ldy (i6),a1 //executed in jr delay slot


//This is a GPIO interrupt that stores 16 LSBs of timer 1 to X variable _edgeTime
  jmpi gpio0_int,(i6)+1 // DO NOT MOVE!!!	
gpio0_int:
	  // Context Save
	stx i0,(i6)    ; sty i1,(i6)
	
	ldc TIMER_T1CNTL,i0
	ldx (i0),i1
	.import _edgeTime
	ldc _edgeTime,i0
	stx i1,(i0)

	ldc 8,i0
	ldc GPIO0_INT_PEND,i1
	stx i0,(i1)

#if 0
// Debugging code: Toggle CS2 (GPIO0:14) whenever GPIO int occurs	
	ldx (i6)+1,null
	stx mr0,(i6)+1;	sty a0,(i6)
	stx b0,(i6);	sty c0,(i6)

	ldc 1<<14,a0
	ldc GPIO0_ODATA,i0
	ldx (i0),b0
	xor b0,a0,a0
	stx a0,(i0)

	ldx (i6)-1,b0;	ldy (i6),c0
	ldx (i6)-1,mr0;	ldy (i6),a0
#endif

	ldc INT_GLOB_EN,i1 //Acknowledge
	ldx (i6),i0
	reti
	stx i1,(i1)       ; ldy (i6)-1,i1 //Allow interrupts


	
//This fuction sets the vector to point to caller stub...
//This is done by copying a caller opcode to the vector(!)
	.sect code,SetInterruptVector_DAC
	.export _SetInterruptVector_DAC	
_SetInterruptVector_DAC:
	ldx (i6)+1,null
	stx a0,(i6) ; sty a1,(i6)
	ldc my_dac_int - 1,i7
	ldi (i7),a    //Read caller opcode from timer1_int_stub-1
	ldc 0x0020,i7 //Select vector... 0x0029 is GPIO0 vector
	sti a,(i7)    //Insert the caller opcode to the vector
	nop           //no control change possible just after sti/ldi!
	jr
	ldx (i6)-1,a0 ; ldy (i6),a1 //executed in jr delay slot

	
	
	jmpi my_dac_int,(i6)+1 // DO NOT MOVE!!!	
my_dac_int:
	STY I1,(I6)+1
	STX I3,(I6)+1 ; STY I2,(I6)
	STX MR0,(I6)+1 ; STY I7,(I6)
#if 1
	  // Context Save
	stx lr1,(i6)+1    ; sty lr0,(i6)
	stx a2,(i6)+1     ; sty b2,(i6)
	stx c2,(i6)+1     ; sty d2,(i6)
	stx a1,(i6)+1     ; sty a0,(i6)
	add null,p,a
	stx a1,(i6)+1     ; sty a0,(i6)
	ldc 0x200,mr0
	.import _InterruptHandler_DAC
	call _InterruptHandler_DAC
	sty i5,(i6)

  // Context Restore	
	ldy (i6)-1,i5
	ldx (i6)-1,a1     ; ldy (i6),a0
	resp a0,a1
	ldx (i6)-1,a1     ; ldy (i6),a0
	ldx (i6)-1,c2     ; ldy (i6),d2
	ldx (i6)-1,a2     ; ldy (i6),b2
	ldx (i6),lr1    ; ldy (i6),lr0
#endif			

	
	j 0x7df2
	nop		


.sect code,Sat16 // 4 words
.export _Sat16
_Sat16:	
    ADD A0,NULL,A1 ; MV A1,A2
    SAT A,A
    JR
    ADD A1,NULL,A0

    .end	
	
		
