#ifndef _MMCMAPPER_H_
#define _MMCMAPPER_H_
#include <vstypes.h>

#define LED2_OFF PERIP(GPIO1_ODATA) &= ~LED2;
#define LED2_ON PERIP(GPIO1_ODATA) |= LED2;

#ifndef ASM
enum mmcState {
    mmcNA = 0,
    mmcOk = 1,
    mmcWriteWait = 2, /* waiting for write to finish */
};
struct MMC {
    enum mmcState state;
    s_int16 errors;
    s_int16 hcShift;
    u_int32 blocks;
    /****/
    u_int16 fileName[12/2];   /* in packed format */
    u_int32 dirBlock;
    s_int16 dirLine;
    u_int32 smallerFreeStart;
    u_int32 smallerFreeSize;
    u_int32 largestFreeStart; /* start in 512-byte blocks */
    u_int32 largestFreeSize;  /* size in 512-byte blocks */
    u_int32 fileSize;         /* saved size in bytes */
};
#define mmc btmp         /**/
extern __y struct MMC mmc;
extern const struct FsMapper mmcMapper;

s_int16 FsInitializeMmc(s_int16 tries);
struct FsMapper *FsMapMmcCreate(struct FsPhysical *physical,
                                u_int16 cacheSize);
u_int16 FsMapMmcRead(struct FsMapper *map, u_int32 firstBlock,
                     u_int16 blocks, u_int16 *data);
u_int16 FsMapMmcWrite(struct FsMapper *map, u_int32 firstBlock,
                      u_int16 blocks, u_int16 *data);
auto u_int16 MyReadDiskSector(register __i0 u_int16 *buffer,
                              register __reg_a u_int32 sector);
s_int16 FsGetFreeSectors(void *private, u_int32 sector, u_int32 numSecs);

//auto s_int16 FatFindDirEntry(const u_int16 *packedName /*8.3 name*/);
void FatPrepareForSaving(void);
void FsFatAllocate(u_int32 start, u_int32 length, u_int16 free);
/* Use 0x0fffffffUL for link when ending a file/directory. */
void FsFatAllocate2(u_int32 start, u_int32 length, u_int32 link, u_int16 free);
int FsFatMakeFile(void);
//void FsPrintSector(u_int32 sector);

/*Misc support routines*/
u_int16 MyCsRead(struct CodecServices *cs, u_int16 *data,
                 u_int16 firstOdd, u_int16 bytes);
void MyPowerOff(void);
#endif



#endif/*_MMCMAPPER_H_*/
