#define FFDE_OK          0
#define FFDE_FAT12       1
#define FFDE_NOSPACE     2
#define FFDE_NAMEINVALID 3

auto s_int16 FatFindDirEntry(const u_int16 *packedName /*8.3 name*/) {
    register __i1 __y struct FRAGMENT *curFragment;
    __y struct FRAGMENT * __y nextFragment;
    register __b u_int32 currentSector;
    register __i3 int i;

    /* Start at the start of root directory. */
    if (minifatInfo.IS_FAT_32) {
	nextFragment = FatFragmentList(&minifatFragments[0], 2);
    } else if (minifatInfo.FilSysType != 0x3231) {
	minifatFragments[0].start = minifatInfo.rootStart | LAST_FRAGMENT;
	minifatFragments[0].size  = ((s_int16)minifatInfo.BPB_RootEntCnt >> 4);
	nextFragment = &minifatFragments[1];
    } else {
	return FFDE_FAT12;	/*FAT12 not supported*/
    }
    //return FatHandleDir(curFragment, nextFragment);

 again:
    mmc.dirLine = -1;
    curFragment = &minifatFragments[0];
    minifatInfo.parentDir = currentSector = curFragment->start & 0x7fffffffUL;
    i = 0;
#pragma msg 36 off
    goto getfirst;
    while (1) {
	register __d1 u_int16 fn = FatGetByte(i+0); /*first char of filename*/
#pragma msg 36 on
	if (fn == 0xe5 || fn == 0) {/* 0xe5 / 0x00 deleted or unused entry */
	    /* Found! */
	    if (mmc.dirLine < 0) {
#if DEBUG_LEVEL > 0
		puthex(currentSector);
		putchar(' ');
		puthex(i);
		puts(" Found!");
#endif
		mmc.dirLine = i;
		mmc.dirBlock = currentSector;
	    }
	} else {
	    register int attr = FatGetByte(i+11/*Attr*/);
	    /* Is it our "VOICE" subdirectory? */
#if DEBUG_LEVEL > 2
	    if ((attr & 0x10) || (attr & 0xde) == 0) {
		putchar(minifatBuffer[i/2]>>8);
		putchar(minifatBuffer[i/2]);
		putchar(minifatBuffer[i/2+1]>>8);
		putchar(minifatBuffer[i/2+1]);
		putchar(minifatBuffer[i/2+2]>>8);
		putchar(minifatBuffer[i/2+2]);
		putchar(minifatBuffer[i/2+3]>>8);
		putchar(minifatBuffer[i/2+3]);
		putchar('.');
		putchar(minifatBuffer[i/2+4]>>8);
		putchar(minifatBuffer[i/2+4]);
		putchar(minifatBuffer[i/2+5]>>8);
	    }
#endif
#if 0 /*Support VOICE subdir*/
	    if ((attr & 0x10)) {
		/*Subdirectory*/
#if DEBUG_LEVEL > 2
		puts(" DIR");
#endif
		if (!memcmp(minifatBuffer + i/2,
			    SOUND_DIR_PACKED, 8/2)) {
#if DEBUG_LEVEL > 0
		    puts("Found " SOUND_DIR);
#endif
		    nextFragment =
			FatFragmentList(&minifatFragments[0],
					((u_int32)FatGetWord(i+20)<<16) +
					FatGetWord(i+26));
		    goto again;
		}
	    } else
#endif
	    if ((attr & 0xde) == 0) {
#if DEBUG_LEVEL > 2
		puts(" FILE");
#endif
		/* Regular file -- check filename */
#if 0
		if (!memcmp(minifatBuffer+i/2, packedName, 11/2) &&
		    (minifatBuffer[i/2+11/2] & 0xff00) == packedName[11/2]) {
		    return FFDE_NAMEINVALID;
		}
#else
		if ((memcmp(minifatBuffer+i/2, packedName, 11/2) |
		     ((minifatBuffer[i/2+11/2] & 0xff00) - packedName[11/2]))
		    == 0) {
		    return FFDE_NAMEINVALID;
		}
#endif
	    }
	}
	i = (i + 32) & 511;
	if (i == 0) {
	    /* if end of directory block, get the next one */
	    currentSector++;
	    if (currentSector >=
		(curFragment->start & 0x7fffffffUL) + curFragment->size) {
		if ((s_int32)curFragment->start < 0) {
		    if (mmc.dirLine < 0) {
#ifdef EXTEND_DIRECTORY
			/* Increase the directory size. */
			if (minifatInfo.IS_FAT_32) {
			    mmc.dirLine = 0;
			    if ((mmc.dirBlock = mmc.smallerFreeStart)) {
				/* another entry is not created, so leave
				   the start address un-updated. */
				//mmc.smallerFreeStart += minifatInfo.fatSectorsPerCluster;
				mmc.smallerFreeSize -= minifatInfo.fatSectorsPerCluster;
			    } else {
				mmc.dirBlock = mmc.largestFreeStart;
				mmc.largestFreeStart += minifatInfo.fatSectorsPerCluster;
				mmc.largestFreeSize -= minifatInfo.fatSectorsPerCluster;
			    }
#if DEBUG_LEVEL > 1
			    puthex(mmc.dirBlock>>16);
			    puthex(mmc.dirBlock);
			    puts("=new dirblock");
#endif
			    /*Allocate new cluster for directory. */
			    FsFatAllocate2(mmc.dirBlock,
					   1 /*fatSectorsPerCluster*/,
					   0x0fffffffUL,
					   0);
			    /*Fix the cluster chain link. */
			    FsFatAllocate2(currentSector-1,
					   1 /*fatSectorsPerCluster*/,
					   (mmc.dirBlock-minifatInfo.dataStart)
					   / minifatInfo.fatSectorsPerCluster,
					   0);
			    /*Clear the new dirblocks */
			    memset(minifatBuffer, 0, sizeof(minifatBuffer));
			    for (i=0; i<minifatInfo.fatSectorsPerCluster; i++){
				FsMapMmcWrite(map,
					      mmc.dirBlock+(u_int16)i,
					      1,
					      minifatBuffer);
			    }
			} else
#endif
			{
#if DEBUG_LEVEL > 0
			    puts("Dir FULL!");
#endif
			    return FFDE_NOSPACE;
			}
		    }
		    return FFDE_OK;
		}
		curFragment++;
		currentSector = curFragment->start & 0x7fffffffUL;
	    }
#if 0 && defined(USE_DEBUG)
	    puthex(currentSector);
#endif
	getfirst:
	    ReadDiskSector(minifatBuffer,
			   minifatInfo.currentSector = currentSector);
	}
    }
}

int FsFatMakeFile(void) {
    {
      register s_int32 t = mmc.fileSize - 8;
      

#ifdef MMC_USE_MULTIWRITE
      if (mmcDoMultiWrite) {
	mmcDoMultiWrite = 0;
	SpiSendReceiveMmc(0xfffd,16);
	while ( SpiSendReceiveMmc(0xff00U, 8) != 0x00ffU){
	  //puts("Busy");
	};
      }
#endif

      FsInitializeMmc(50);

      ReadDiskSector(minifatBuffer,
		     minifatInfo.currentSector =
		     mmc.largestFreeStart);
      minifatBuffer[2] = SwapWord(t);
      minifatBuffer[3] = SwapWord(t>>16);
      t -= 0x24;
      minifatBuffer[20] = SwapWord(t);
      minifatBuffer[21] = SwapWord(t>>16);
      /* We don't care if it fails or not. */
      FsMapMmcWrite(map, mmc.largestFreeStart, 1,
		    minifatBuffer);
    }
    
    {
      register u_int32 cluster =
	(mmc.largestFreeStart - minifatInfo.dataStart)
	/ minifatInfo.fatSectorsPerCluster;
      
      
      if (mmc.dirLine < 0)
	return 1;
      
      /* allocate sectors */
#if 0
      FsFatAllocate(mmc.largestFreeStart, mmc.fileSize / 512, 0);
#else
      FsFatAllocate2(mmc.largestFreeStart, mmc.fileSize / 512, 0x0fffffffUL, 0);
#endif
      
      ReadDiskSector(minifatBuffer, minifatInfo.currentSector = mmc.dirBlock);
      
      /*4B4F4546494C45315241570000C62E000000700033000000FFFFDA09FFFFFFFF
	name -----------------
	attr 11               --
	ntres 12                --
	crt time 13 14 16         tttimedate
	last access date 18                 ----
	cluster hi 20                           ----
	write time 22 24                            timedate
	cluster low 26                                      ----
	filesize 28                                             --------
      */
      {
	register u_int16 *p;
	p = minifatBuffer + mmc.dirLine/2;
	memset(p, 0, 32/2);
	memcpyYX(p, mmc.fileName, 12/2);
	p += 10/2;
	//*p |= attrib;
	p += (20-10)/2;
	*p = SwapWord(cluster>>16);//Cluster HI
	p += (26-20)/2;
	*p = SwapWord(cluster); //Cluster LO
	p += (28-26)/2;
	p[0] = SwapWord(mmc.fileSize);
	p[1] = SwapWord(mmc.fileSize>>16);
      }
      if (FsMapMmcWrite(map, mmc.dirBlock, 1, minifatBuffer) != 1) {
#if DEBUG_LEVEL > 0
	puts("write failed??");
	puthex(mmc.errors);
	puts("=mmc.errors");
#endif
      }
#if DEBUG_LEVEL > 1
      puts("New dir block");
      //    FsPrintSector(mmc.dirBlock);
#endif           
#ifdef MMC_USE_MULTIWRITE      
      mmcDoMultiWrite = 1;
#endif

      return 0;
    }
}

/*
  Can be used for allocating a range of clusters (sectors),
  and rewriting old links.
 */
void FsFatAllocate2(u_int32 start, u_int32 length, u_int32 link, u_int16 free){
    register u_int32 fatSector;
    register u_int16 fatLine;
    length = (length + minifatInfo.fatSectorsPerCluster - 1)
	/ minifatInfo.fatSectorsPerCluster;
    start = (start - minifatInfo.dataStart) / minifatInfo.fatSectorsPerCluster;
    if (minifatInfo.IS_FAT_32) {
	fatSector = minifatInfo.fatStart + ((s_int32)start >> 7);
	fatLine   = ((u_int16)start << 2);
    } else {
	fatSector = minifatInfo.fatStart + ((s_int32)start >> 8);
	fatLine   = ((u_int16)start << 1);
    }
    fatLine &= 511;

#if DEBUG_LEVEL > 0
    puthex(length);
    puts("=clusters");
    puthex(start>>16);
    puthex(start);
    puts("=start cluster");
    puthex(fatSector);
    putchar(' ');
    puthex(fatLine);
    puts("=fat sector,line");
#endif
#pragma msg 36 off
    goto read;
    while (length) {
#pragma msg 36 on
	length = length-1;

	/* no need to read old link, we do not do sanity checks anymore */
#if DEBUG_LEVEL > 3
	puthex(start);
	puthex(fatLine);
	puts("");
#endif
	{
	    register u_int32 t = ++start; /* points to next cluster here */
	    if (length == 0)
		t = link; /* last one: 0x0fffffffUL for end or next chain */
	    if (free)
		t = 0; /* Free it.. */
	    minifatBuffer[fatLine/2] = SwapWord(t);
	    fatLine += 2;
	    if (minifatInfo.IS_FAT_32) {
		/*fatLine has been added by 2, so use fatLine/2 again! */
		minifatBuffer[fatLine/2] = SwapWord(t>>16);
		fatLine += 2; /*another 2 makes 4 total*/
	    }
	}
	fatLine &= 511;
	if (fatLine == 0 || length == 0) {
#if DEBUG_LEVEL > 0
	    puthex(fatSector);
	    puts("=fatSector Wr");
#endif
	    if (FsMapMmcWrite(map, fatSector, 1, minifatBuffer) != 1) {
#if DEBUG_LEVEL > 0
		puts("write failed??");
		puthex(mmc.errors);
		puts("=mmc.errors");
		//FsPrintSector(fatSector);
#endif
	    }
#if DEBUG_LEVEL > 0
	    //FsPrintSector(fatSector);
#endif
	}
	if (fatLine != 0)
	    continue;
	fatSector++;
    read:
	ReadDiskSector(minifatBuffer,
		       minifatInfo.currentSector = fatSector);
#if DEBUG_LEVEL > 0
	puthex(fatSector);
	puts("=fatSector Rd");
	//FsPrintSector(fatSector);
#endif
    }
}

s_int16 FsGetFreeSectors(void *private, u_int32 sector, u_int32 numSecs) {
#if 0
    register __y struct FRAGMENT *fr = *(__y struct FRAGMENT *__x*)private;
    if (private) {
	fr->start = sector;
	fr->size  = numSecs;
	fr++;
	*(__y struct FRAGMENT *__x*)private = fr;
    }
#endif
    if (numSecs > mmc.largestFreeSize) {
#ifdef EXTEND_DIRECTORY
	mmc.smallerFreeSize = mmc.largestFreeSize;
	mmc.largestFreeSize = numSecs;
	mmc.smallerFreeStart = mmc.largestFreeStart;
	mmc.largestFreeStart = sector;
#else
	mmc.largestFreeSize = numSecs;
	mmc.largestFreeStart = sector;
#endif
    }
#if 0
    puthex(sector>>16);
    puthex(sector);
    //putchar(' ');
    puthex(numSecs>>16);
    puthex(numSecs);
    puts("=sec,num");
#endif
    return 0;
}

